unit hiSleep;

interface

uses Kol,Share,Windows,Debug;

type
  THISleep = class(TDebug)
    private
    public
      _prop_Delay: Integer;
      _event_onSleep: THI_Event;
      _data_Delay: THI_Event;
      procedure _work_doSleep(var _Data: TData; Index: Word);
      procedure _work_doSleepMks(var _Data: TData; Index: Word);
      procedure _work_doSleepStd(var _Data: TData; Index: Word);
  end;

implementation

var
  Frequency: Int64;

procedure THISleep._work_doSleep;
var 
  sp, ep: Int64;
  t: Integer;
begin
  t := ReadInteger(_Data, _data_Delay, _prop_Delay);
  QueryPerformanceCounter(sp);
  repeat
    QueryPerformanceCounter(ep);
  until ep - sp > t;
  _hi_OnEvent(_event_onSleep, _Data);
end;

procedure THISleep._work_doSleepMks;
var 
  sp, ep: Int64;
  t: Integer;
begin
  t := ReadInteger(_Data, _data_Delay, _prop_Delay);
  QueryPerformanceCounter(sp);
  repeat
    QueryPerformanceCounter(ep);
  until (ep - sp) div Frequency > t;
  _hi_OnEvent(_event_onSleep, _Data);
end;

procedure THISleep._work_doSleepStd;
begin
  Sleep(ReadInteger(_Data, _data_Delay, _prop_Delay) div 1000);
  _hi_OnEvent(_event_onSleep, _Data);
end;

initialization
  
  QueryPerformanceFrequency(Frequency);
  Frequency := Frequency div 1000000;
  
end.
